/*
  Maxwell's Lemur
  Copyright (c) 1997 Daniel Risacher <magnus@alum.mit.edu>
  
  Siag, Scheme In A Grid
  Copyright (C) 1996, 1997  Ulric Eriksson <ulric@edu.stockholm.se>
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2, or (at your option)
  any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __GUI_H__
#define __GUI_H__

#include "../ngrid/ngrid.h"
#include "../basic/core.h"

typedef enum
{
  PAGE_STATE_BROWSING,
  PAGE_STATE_ENTERING
} NotePageState;

typedef struct _npage {
  GtkWidget *npage_table;
  GtkWidget *npage_label;
  GtkWidget *ngrid;
  GtkWidget *hscrollbar;
  GtkWidget *vscrollbar;
  GtkWidget *entry;
  NotePageState state;
  buffer *buf;
  buffer_page *bpage;
  position mark_pos;	/* mark */
  struct _npage *next;
} notepage;


typedef struct _window {
  position point_pos;	/* point */
  position top;		/* left top of visible part of buffer */
  position prot;	/* protected lines/cols */
  position blku, blkl;	/* upper left & lower right block corners */
  gint begin_y;		/* position on the screen */
  gint max_y;		/* height in lines */
  GtkWidget *gtkwindow;
  GtkWidget *windowbox;
  GtkWidget *notebook;
  GtkWidget *menubar;
  struct _npage *pages;
  struct _window *next;	/* next window in window ring */
} window;

#include "npage.h"
#include "window.h"
#include "fileops.h"
#include "ngrid_functions.h"

#endif
