#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include "gui.h"

notepage *npage_concat(notepage *page1, notepage* page2)
{
  notepage *temp;
  temp = page1;
  while (temp) {
    page1 = temp;
    temp = page1->next;
  }
  page1->next = page2;
  return page1;
}

gint
ng_entry_activate (GtkWidget *entry,
		   GdkEvent  *event)
{
  notepage *npage;
  gint row, col;
  npage = (notepage *) gtk_object_get_user_data (GTK_OBJECT (entry));
  gtk_ngrid_get_point(GTK_NGRID(npage->ngrid), &row, &col);
  
  ins_data (npage->bpage, 
	    name2interpreter("Guile"),
	    gtk_entry_get_text(GTK_ENTRY(entry)), CELL_TYPE_EXPRESSION,
	    0.0, VALUE_TYPE_UNCALCULATED,
	    row, col);
  calc_matrix(npage->buf); 
  gtk_ngrid_expose(npage->ngrid,NULL);
  gtk_widget_grab_focus(GTK_WIDGET(npage->ngrid));
  npage->state = PAGE_STATE_BROWSING;
  return TRUE;
}  

void npage_set_point(notepage *npage, gint row, gint col) 
{
  gchar *text;
  text = ret_formula(npage->bpage,row,col);
  text = text?text:"";
  gtk_entry_set_text(GTK_ENTRY(npage->entry), text);
  gtk_ngrid_set_point(GTK_NGRID(npage->ngrid), row, col);
}  

notepage *npage_new(buffer *b, buffer_page *bp) 
{
  notepage *p;
  GtkWidget *page_table;
  GtkWidget *page_label;
  GtkWidget *ngrid;
  GtkWidget *hscrollbar;
  GtkWidget *vscrollbar;
  GtkWidget *entry;

  guint8 hscrollbar_policy;
  guint8 vscrollbar_policy;

  hscrollbar_policy = GTK_POLICY_ALWAYS;
  vscrollbar_policy = GTK_POLICY_ALWAYS;

  page_label = gtk_label_new(bp->name);
  page_table = gtk_table_new (3,3,FALSE);
  gtk_table_set_row_spacings (GTK_TABLE (page_table), 1);
  gtk_table_set_col_spacings (GTK_TABLE (page_table), 1);
  gtk_container_border_width (GTK_CONTAINER (page_table), 10);
  gtk_widget_show (page_table);
  gtk_widget_show (page_label);

  ngrid = gtk_ngrid_new(1000,1000);  /*FIXME*/
  gtk_ngrid_size(GTK_NGRID(ngrid),500,300);
  assimilate_ngrid(GTK_NGRID(ngrid));

  entry = gtk_entry_new();

  hscrollbar = gtk_hscrollbar_new (gtk_ngrid_get_hadjustment(GTK_NGRID(ngrid)));
  GTK_WIDGET_UNSET_FLAGS (hscrollbar, GTK_CAN_FOCUS);

  vscrollbar = gtk_vscrollbar_new (gtk_ngrid_get_vadjustment(GTK_NGRID(ngrid)));
  gtk_range_set_update_policy (GTK_RANGE (hscrollbar), GTK_UPDATE_CONTINUOUS);
  gtk_range_set_update_policy (GTK_RANGE (vscrollbar), GTK_UPDATE_CONTINUOUS);
 
  gtk_widget_show (entry);
  gtk_widget_show (ngrid);
  gtk_widget_show (hscrollbar);
  gtk_widget_show (vscrollbar);

  gtk_table_attach (GTK_TABLE (page_table), entry, 0, 1, 0, 1,
                    GTK_EXPAND | GTK_SHRINK | GTK_FILL, GTK_FILL, 0, 0);
  gtk_table_attach (GTK_TABLE (page_table), ngrid, 0, 1, 1, 2,
                    GTK_EXPAND | GTK_SHRINK | GTK_FILL,
                    GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
  gtk_table_attach (GTK_TABLE (page_table), hscrollbar, 0, 1, 2, 3,
                    GTK_EXPAND | GTK_SHRINK | GTK_FILL, GTK_FILL, 0, 0);
  gtk_table_attach (GTK_TABLE (page_table), vscrollbar, 1, 2, 1, 2,
                    GTK_FILL, GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);

  p = g_new(notepage,1);
  p->npage_table = page_table;
  p->npage_label = page_label;
  p->ngrid = ngrid;
  p->hscrollbar = hscrollbar;
  p->vscrollbar = vscrollbar;
  p->entry = entry;
  p->next = NULL;
  p->buf = b;
  p->bpage = bp;
    
  gtk_object_set_user_data (GTK_OBJECT (ngrid), (gpointer) p);     
  gtk_object_set_user_data (GTK_OBJECT (entry), (gpointer) p);     
  gtk_ngrid_set_point(GTK_NGRID(ngrid), 1, 1);

  gtk_signal_connect (GTK_OBJECT (entry), "activate",
                      (GtkSignalFunc) ng_entry_activate,
                      entry);
  
  return p;
}
